// This is a scripted coppercube action.
// Makes a WebGL use the full page. Execute this action once (like for example in the "Before first drawing do something" behavior of the root element of the first scene, and your WebGL app will from now use the full page.
//
/*
	<action jsname="action_MakeWebGLFullPage" description="Make WebGL use the full page">
		<property name="ClearPage" type="bool" default="true" />
	</action>
*/

action_MakeWebGLFullPage = function()
{
};

// called when the action is executed 
action_MakeWebGLFullPage.prototype.execute = function(currentNode)
{
	if (ccbGetPlatform() == 'webgl' && action_MakeWebGLFullPageEnabled == false) 
	{
		action_MakeWebGLFullPageEnabled = true;
		
		// set body style
		
		document.body.style.margin = "0px 0px 0px 0px";
		document.body.style.overflow = 'hidden';
			
		var elements = document.getElementsByTagName('canvas');
		if (elements.length > 0)
		{
			var canvasElem = elements[0];
			var pnode = canvasElem.parentElement;		
						
			// move canvas before body
					
			pnode.removeChild(canvasElem);
			var body = document.body;
			body.insertBefore(canvasElem, body.firstChild);
			
			// erase children after canvas

			if (this.ClearPage)
				this.eraseAllChildrenAfter(body, canvasElem);	
		}
		
		// set update handler
		
		var me = this;
		setInterval(function(){me.makeFrameWholeElementSize();}, 500);
		me.makeFrameWholeElementSize();
	}
}

action_MakeWebGLFullPageEnabled = false;
action_MakeWebGLFullPage.prototype.lastParentElementWidth = 0;
action_MakeWebGLFullPage.prototype.lastParentElementHeight = 0;


action_MakeWebGLFullPage.prototype.eraseAllChildrenAfter = function(parentnode, afterthisnode)
{
	var cfound = false;
	for (var i=0; i<parentnode.children.length; ++i)
	{
		var c = parentnode.children[i];
		if (!cfound && c == afterthisnode)
		{
			cfound = true;
			++i;
		}
		else
			parentnode.removeChild(c);
	}
}

action_MakeWebGLFullPage.prototype.makeFrameWholeElementSize = function()
{
	var elements = document.getElementsByTagName('canvas');
	var pnode = null;
	var canvasElem = null;
	
	if (elements.length > 0)
	{
		canvasElem = elements[0];
		pnode = canvasElem.parentElement;
	}
			
	if (pnode != null)
	{
		var w = pnode.innerWidth || pnode.clientWidth;
		var h = pnode.innerHeight || pnode.clientHeight;
		
		if (w != null && h != null &&
			(w != this.lastParentElementWidth || h != this.lastParentElementHeight))
		{
			// resize
			canvasElem.width = w;
			canvasElem.height = h;
				
			// store last size
			this.lastParentElementWidth = w;
			this.lastParentElementHeight = h;			
		}
	}
}